package premium_store.model;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

@Entity
public class Client {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    @Column(nullable = false, length = 255)
    private String nickName;

    @Column(nullable = false, length = 255)
    private String email;

    private Integer balance;

    @OneToMany(fetch= FetchType.EAGER)
    private List<Tank> tanks = new ArrayList<>();

    public Client(){ }

    public Client(String nickName, String email, Integer balance){
        this.nickName = nickName;
        this.email = email;
        this.balance = balance;
    }

    public Long getId(){
        return id;
    }

    public String getNickName(){
        return nickName;
    }

    public void setNickName(String nickName){
        this.nickName = nickName;
    }

    public String getEmail(){
        return email;
    }

    public void setEmail(String email){
        this.email = email;
    }

    public Integer getBalance(){
        return balance;
    }

    public void setBalance(Integer balance){
        this.balance = balance;
    }

    public List<Tank> getTanks(){
        return tanks;
    }

    public void setTanks(List<Tank> tanks){
        this.tanks = tanks;
    }

    //метод для сравнения
    @Override
    public boolean equals(Object o) {
        if (this == o)
            return true;

        if (o == null || getClass() != o.getClass())
            return false;

        Client client = (Client) o;

        return Objects.equals(id, client.id);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id);
    }

    //преобразование данных по объекту в строчку
    @Override
    public String toString() {
        return "Client{" +
                "id=" + id +
                ", nickName='" + nickName + '\'' +
                ", email='" + email + '\'' +
                ", balance='" + balance + '\'' +
                ", tanks='" + tanks.stream().map(Object::toString).collect(Collectors.joining(", ")) + '\'' +
                '}';
    }
}
